#ifndef __UTILS_H
#define __UTILS_H

#include <vector>

using namespace std;

double mean(double* data, int start, int end);

double stdev(double* data, int start, int end, double m, bool hasMean);

double stdev(double* data, int start, int end);

void znormalize(double* data, int start, int end);

void arraycopy(double* src, int srcpos, double* dst, int dstpos, int size);

double* sqreuclid_dist(double* x, double* y, int size, bool earlyAbandon, double mindist);

double* sqreuclid_distf(float* x, float* y, int size, bool earlyAbandon, double mindist);

double* sqr_rotatdist(float* x, float* y, int size, bool earlyAbandon, double mindist);

double* shifted_sqreucliddist(float* x, float* y, int posy, int size, bool earlyAbandon, double mindist);

void cleanContainer(vector <float*>& cont);

double round(double x);

#endif
